import { world, system } from '@minecraft/server';
const rails = [
	'minecraft:rail',
	'minecraft:detector_rail',
	'minecraft:activator_rail',
	'minecraft:golden_rail'
];
const dirs = [2, 3, 4, 5];
system.afterEvents.scriptEventReceive.subscribe(event => {
  let eb = event.sourceEntity;
	let v = eb.getViewDirection();
	let vel = eb.getVelocity();
	let vx = v.x > 0.1 ? 1 : v.x < 0 ? -1 : v.x == 0 ? 0 : 'tf';
	let dirX = vel.x > 0 ? 1 : vel.x == 0 ? 0 : -1;
	let dirY = vel.y > 0 ? 1 : vel.y == 0 ? 0 : -1;
	let dirZ = vel.z > 0 ? 1 : vel.z == 0 ? 0 : -1;
	if(event.id == 'raigen:check'){
		let {x, y, z} = eb.location;
		let block = eb.dimension.getBlock({x, y, z});
		if(!rails.includes(block.typeId)) return;
		let railDir = block.permutation.getState('rail_direction');
		if(dirs.includes(railDir)){
			let cond1 = railDir == 3 && dirX == 1 && dirY == -1 && dirZ == 0 && vx == 0;
			let cond2 = railDir == 3 && dirX == -1 && dirY == 1 && dirZ == 0 && vx == 0;
			let cond3 = railDir == 4 && dirX == 0 && dirY == 1 && dirZ == -1 && vx == 1;
			let cond4 = railDir == 4 && dirX == 0 && dirY == -1 && dirZ == 1 && vx == 1;
			let cond5 = railDir == 5 && dirX == 0 && dirY == -1 && dirZ == -1 && vx == -1;
			let cond6 = railDir == 5 && dirX == 0 && dirY == 1 && dirZ == 1 && vx == -1;
			let cond7 = railDir == 2 && dirX == -1 && dirY == -1 && dirZ == 0 && vx == 'tf';
			let cond8 = railDir == 2 && dirX == 1 && dirY == 1 && dirZ == 0 && vx == 'tf';
			if(cond1 || cond2 || cond3 || cond4 || cond5 || cond6 || cond7 || cond8){
				eb.triggerEvent('raigen:event_x_down');
			}
			else{
				eb.triggerEvent('raigen:event_x_up');
			}
		}
		else{
			eb.triggerEvent('raigen:event_x_default');
		}
	}
});